---
title: Debugger.Script
slug: Tools/Debugger-API/Debugger.Script
---
<div>{{ToolsSidebar}}</div><h1 id="Debugger.Script">Debugger.Script</h1>

<p>A <code>Debugger.Script</code> instance may refer to a sequence of bytecode in the debuggee or to a block of WebAssembly code. For the former, it is the <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> API’s presentation of a JSAPI <code>JSScript</code> object. The two cases are distinguished by their <code>format</code> property being <code>"js"</code> or <code>"wasm"</code>.</p>

<h2 id="Debugger.Script_for_JSScripts">Debugger.Script for JSScripts</h2>

<p>For <code>Debugger.Script</code> instances referring to a <code>JSScript</code>, they are distinguished by their <code>format</code> property being <code>"js"</code>.</p>

<p>Each of the following is represented by a single <code>JSScript</code> object:</p>

<ul>
 <li>
  <p>The body of a function—that is, all the code in the function that is not contained within some nested function.</p>
 </li>
 <li>
  <p>The code passed to a single call to <code>eval</code>, excluding the bodies of any functions that code defines.</p>
 </li>
 <li>
  <p>The contents of a <code>&lt;script&gt;</code> element.</p>
 </li>
 <li>
  <p>A DOM event handler, whether embedded in HTML or attached to the element by other JavaScript code.</p>
 </li>
 <li>
  <p>Code appearing in a <code>javascript:</code> URL.</p>
 </li>
</ul>

<p>The <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> interface constructs <code>Debugger.Script</code> objects as scripts of debuggee code are uncovered by the debugger: via the <code>onNewScript</code> handler method; via <a href="Debugger.Frame"><code>Debugger.Frame</code></a>’s <code>script</code> properties; via the <code>functionScript</code> method of <a href="Debugger.Object"><code>Debugger.Object</code></a> instances; and so on. For a given <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance, SpiderMonkey constructs exactly one <code>Debugger.Script</code> instance for each underlying script object; debugger code can add its own properties to a script object and expect to find them later, use <code>==</code> to decide whether two expressions refer to the same script, and so on.</p>

<p>(If more than one <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance is debugging the same code, each <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> gets a separate <code>Debugger.Script</code> instance for a given script. This allows the code using each <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance to place whatever properties it likes on its <code>Debugger.Script</code> instances, without worrying about interfering with other debuggers.)</p>

<p>A <code>Debugger.Script</code> instance is a strong reference to a JSScript object; it protects the script it refers to from being garbage collected.</p>

<p>Note that SpiderMonkey may use the same <code>Debugger.Script</code> instances for equivalent functions or evaluated code—that is, scripts representing the same source code, at the same position in the same source file, evaluated in the same lexical environment.</p>

<h2 id="Debugger.Script_for_WebAssembly">Debugger.Script for WebAssembly</h2>

<p>For <code>Debugger.Script</code> instances referring to a block of WebAssembly code, they are distinguished by their <code>format</code> property being <code>"wasm"</code>.</p>

<p>Currently only entire modules evaluated via <code>new WebAssembly.Module</code> are represented.</p>

<p><code>Debugger.Script</code> objects for WebAssembly are uncovered via <code>onNewScript</code> when a new WebAssembly module is instantiated and via the <code>findScripts</code> method on <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instances. SpiderMonkey constructs exactly one <code>Debugger.Script</code> for each underlying WebAssembly module per <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance.</p>

<p>A <code>Debugger.Script</code> instance is a strong reference to the underlying WebAssembly module; it protects the module it refers to from being garbage collected.</p>

<p>Please note at the time of this writing, support for WebAssembly is very preliminary. Many properties and methods below throw.</p>

<h2 id="Convention">Convention</h2>

<p>For descriptions of properties and methods below, if the behavior of the property or method differs between the instance referring to a <code>JSScript</code> or to a block of WebAssembly code, the text will be split into two sections, headed by “<strong>if the instance refers to a <code>JSScript</code></strong>” and “<strong>if the instance refers to WebAssembly code</strong>”, respectively. If the behavior does not differ, no such emphasized headings will appear.</p>

<h2 id="Accessor_Properties_of_the_Debugger.Script_Prototype_Object">Accessor Properties of the Debugger.Script Prototype Object</h2>

<p>A <code>Debugger.Script</code> instance inherits the following accessor properties from its prototype:</p>

<dl>
 <dt><code>isGeneratorFunction</code></dt>
 <dd>True if this instance refers to a <code>JSScript</code> for a function defined with a <code>function*</code> expression or statement. False otherwise.</dd>
 <dt><code>isAsyncFunction</code></dt>
 <dd>True if this instance refers to a <code>JSScript</code> for an async function, defined with an <code>async function</code> expression or statement. False otherwise.</dd>
 <dt><code>displayName</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, this is the script’s display name, if it has one. If the script has no display name — for example, if it is a top-level <code>eval</code> script — this is <code>undefined</code>.</p>

 <p>If the script’s function has a given name, its display name is the same as its function’s given name.</p>

 <p>If the script’s function has no name, SpiderMonkey attempts to infer an appropriate name for it given its context. For example:</p>

 <pre class="language-js"><code>function f() {}          // display name: f (the given name)
var g = function () {};  // display name: g
o.p = function () {};    // display name: o.p
var q = {
  r: function () {}      // display name: q.r
};</code></pre>

 <p>Note that the display name may not be a proper JavaScript identifier, or even a proper expression: we attempt to find helpful names even when the function is not immediately assigned as the value of some variable or property. Thus, we use <code><em>a</em>/<em>b</em></code> to refer to the<em>b</em> defined within<em>a</em>, and <code><em>a</em>&lt;</code> to refer to a function that occurs somewhere within an expression that is assigned to<em>a</em>. For example:</p>

 <pre class="language-js"><code>function h() {
  var i = function() {};    // display name: h/i
  f(function () {});        // display name: h/&lt;
}
var s = f(function () {});  // display name: s&lt;</code></pre>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>url</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, the filename or URL from which this script’s code was loaded. For scripts created by <code>eval</code> or the <code>Function</code> constructor, this may be a synthesized filename, starting with a valid URL and followed by information tracking how the code was introduced into the system; the entire string is not a valid URL. For <code>Function.prototype</code>’s script, this is <code>null</code>. If this <code>Debugger.Script</code>’s <code>source</code> property is non-<code>null</code>, then this is equal to <code>source.url</code>.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>startLine</code></dt>
 <dd><strong>If the instance refers to a <code>JSScript</code></strong>, the number of the line at which this script’s code starts, within the file or document named by <code>url</code>.</dd>
 <dt><code>lineCount</code></dt>
 <dd><strong>If the instance refers to a <code>JSScript</code></strong>, the number of lines this script’s code occupies, within the file or document named by <code>url</code>.</dd>
 <dt><code>source</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, the <a href="Debugger.Source"><code>Debugger.Source</code></a> instance representing the source code from which this script was produced. This is <code>null</code> if the source code was not retained.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, the <a href="Debugger.Source"><code>Debugger.Source</code></a> instance representing the serialized text format of the WebAssembly code.</p>
 </dd>
 <dt><code>sourceStart</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, the character within the <a href="Debugger.Source"><code>Debugger.Source</code></a> instance given by <code>source</code> at which this script’s code starts; zero-based. If this is a function’s script, this is the index of the start of the <code>function</code> token in the source code.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>sourceLength</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, the length, in characters, of this script’s code within the <a href="Debugger.Source"><code>Debugger.Source</code></a> instance given by <code>source</code>.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>global</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, a <a href="Debugger.Object"><code>Debugger.Object</code></a> instance referring to the global object in whose scope this script runs. The result refers to the global directly, not via a wrapper or a <code>WindowProxy</code> (“outer window”, in Firefox).</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>format</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, <code>"js"</code>.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, <code>"wasm"</code>.</p>
 </dd>
</dl>

<h2 id="Function_Properties_of_the_Debugger.Script_Prototype_Object">Function Properties of the Debugger.Script Prototype Object</h2>

<p>The functions described below may only be called with a <code>this</code> value referring to a <code>Debugger.Script</code> instance; they may not be used as methods of other kinds of objects.</p>

<dl>
 <dt><code>getAllOffsets()</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, return an array<em>L</em> describing the relationship between bytecode instruction offsets and source code positions in this script.<em>L</em> is sparse, and indexed by source line number. If a source line number<em>line</em> has no code, then<em>L</em> has no<em>line</em> property. If there is code for<em>line</em>, then <code><em>L</em>[<em>line</em>]</code> is an array of offsets of byte code instructions that are entry points to that line.</p>

 <p>For example, suppose we have a script for the following source code:</p>

 <pre class="language-js"><code>a=[]
for (i=1; i &lt; 10; i++)
    // It's hip to be square.
    a[i] = i*i;</code></pre>

 <p>Calling <code>getAllOffsets()</code> on that code might yield an array like this:</p>

 <pre class="language-js"><code>[[0], [5, 20], , [10]]</code></pre>

 <p>This array indicates that:</p>

 <ul>
  <li>
   <p>the first line’s code starts at offset 0 in the script;</p>
  </li>
  <li>
   <p>the <code>for</code> statement head has two entry points at offsets 5 and 20 (for the initialization, which is performed only once, and the loop test, which is performed at the start of each iteration);</p>
  </li>
  <li>
   <p>the third line has no code;</p>
  </li>
  <li>
   <p>and the fourth line begins at offset 10.</p>
  </li>
 </ul>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>getAllColumnOffsets()</code>:</dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, return an array describing the relationship between bytecode instruction offsets and source code positions in this script. Unlike getAllOffsets(), which returns all offsets that are entry points for each line, getAllColumnOffsets() returns all offsets that are entry points for each (line, column) pair.</p>

 <p>The elements of the array are objects, each of which describes a single entry point, and contains the following properties:</p>

 <ul>
  <li>
   <p>lineNumber: the line number for which offset is an entry point</p>
  </li>
  <li>
   <p>columnNumber: the column number for which offset is an entry point</p>
  </li>
  <li>
   <p>offset: the bytecode instruction offset of the entry point</p>
  </li>
 </ul>

 <p>For example, suppose we have a script for the following source code:</p>

 <pre class="language-js"><code>a=[]
for (i=1; i &lt; 10; i++)
    // It's hip to be square.
    a[i] = i*i;</code></pre>

 <p>Calling <code>getAllColumnOffsets()</code> on that code might yield an array like this:</p>

 <pre class="language-js"><code>[{ lineNumber: 0, columnNumber: 0, offset: 0 },
 { lineNumber: 1, columnNumber: 5, offset: 5 },
 { lineNumber: 1, columnNumber: 10, offset: 20 },
 { lineNumber: 3, columnNumber: 4, offset: 10 }]</code></pre>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>getLineOffsets(<em>line</em>)</code></dt>
 <dd><strong>If the instance refers to a <code>JSScript</code></strong>, return an array of bytecode instruction offsets representing the entry points to source line<em>line</em>. If the script contains no executable code at that line, the array returned is empty.</dd>
 <dt><code>getOffsetLocation(<em>offset</em>)</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, return an object describing the source code location responsible for the bytecode at<em>offset</em> in this script. The object has the following properties:</p>

 <ul>
  <li>
   <p>lineNumber: the line number for which offset is an entry point</p>
  </li>
  <li>
   <p>columnNumber: the column number for which offset is an entry point</p>
  </li>
  <li>
   <p>isEntryPoint: true if the offset is a column entry point, as would be reported by getAllColumnOffsets(); otherwise false.</p>
  </li>
 </ul>
 </dd>
 <dt><code>getOffsetsCoverage()</code>:</dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, return <code>null</code> or an array which contains informations about the coverage of all opcodes. The elements of the array are objects, each of which describes a single opcode, and contains the following properties:</p>

 <ul>
  <li>
   <p>lineNumber: the line number of the current opcode.</p>
  </li>
  <li>
   <p>columnNumber: the column number of the current opcode.</p>
  </li>
  <li>
   <p>offset: the bytecode instruction offset of the current opcode.</p>
  </li>
  <li>
   <p>count: the number of times the current opcode got executed.</p>
  </li>
 </ul>

 <p>If this script has no coverage, or if it is not instrumented, then this function will return <code>null</code>. To ensure that the debuggee is instrumented, the flag <code>Debugger.collectCoverageInfo</code> should be set to <code>true</code>.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>getChildScripts()</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, return a new array whose elements are Debugger.Script objects for each function in this script. Only direct children are included; nested children can be reached by walking the tree.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>setBreakpoint(<em>offset</em>,<em>handler</em>)</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, set a breakpoint at the bytecode instruction at<em>offset</em> in this script, reporting hits to the <code>hit</code> method of<em>handler</em>. If<em>offset</em> is not a valid offset in this script, throw an error.</p>

 <p>When execution reaches the given instruction, SpiderMonkey calls the <code>hit</code> method of<em>handler</em>, passing a <a href="Debugger.Frame"><code>Debugger.Frame</code></a> instance representing the currently executing stack frame. The <code>hit</code> method’s return value should be a <a href="Conventions#resumption-values" title="Debugger API: General Conventions: Resumption Values">resumption value</a>, determining how execution should continue.</p>

 <p>Any number of breakpoints may be set at a single location; when control reaches that point, SpiderMonkey calls their handlers in an unspecified order.</p>

 <p>Any number of breakpoints may use the same<em>handler</em> object.</p>

 <p>Breakpoint handler method calls are cross-compartment, intra-thread calls: the call takes place in the same thread that hit the breakpoint, and in the compartment containing the handler function (typically the debugger’s compartment).</p>

 <p>The new breakpoint belongs to the <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance to which this script belongs. Disabling the <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance disables this breakpoint; and removing a global from the <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance’s set of debuggees clears all the breakpoints belonging to that <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance in that global’s scripts.</p>
 </dd>
 <dt><code>getBreakpoints([<em>offset</em>])</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, return an array containing the handler objects for all the breakpoints set at<em>offset</em> in this script. If<em>offset</em> is omitted, return the handlers of all breakpoints set anywhere in this script. If<em>offset</em> is present, but not a valid offset in this script, throw an error.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
 <dt><code>clearBreakpoint(handler, [<em>offset</em>])</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, remove all breakpoints set in this <a href="Debugger" title="The Debugger object"><code>Debugger</code></a> instance that use<em>handler</em> as their handler. If<em>offset</em> is given, remove only those breakpoints set at<em>offset</em> that use<em>handler</em>; if<em>offset</em> is not a valid offset in this script, throw an error.</p>

 <p>Note that, if breakpoints using other handler objects are set at the same location(s) as<em>handler</em>, they remain in place.</p>
 </dd>
 <dt><code>clearAllBreakpoints([<em>offset</em>])</code></dt>
 <dd><strong>If the instance refers to a <code>JSScript</code></strong>, remove all breakpoints set in this script. If<em>offset</em> is present, remove all breakpoints set at that offset in this script; if<em>offset</em> is not a valid bytecode offset in this script, throw an error.</dd>
 <dt><code>isInCatchScope([<em>offset</em>])</code></dt>
 <dd>
 <p><strong>If the instance refers to a <code>JSScript</code></strong>, this is <code>true</code> if this offset falls within the scope of a try block, and <code>false</code> otherwise.</p>

 <p><strong>If the instance refers to WebAssembly code</strong>, throw a <code>TypeError</code>.</p>
 </dd>
</dl>

<h4 id="Source_Metadata">Source Metadata</h4>

<dl>
 <dt>Generated from file:</dt>
 <dt> </dt>
 <dd>js/src/doc/Debugger/Debugger.Script.md</dd>
 <dt>Watermark:</dt>
 <dd id="watermark">sha256:8816a4e8617be32c4ce7f3ae54970fe9c8a7d248175d215a8990ccff23e6efa9</dd>
 <dt>Changeset:</dt>
 <dd><a href="https://hg.mozilla.org/mozilla-central/rev/5572465c08a9">5572465c08a9+</a></dd>
</dl>
